(******************************************************************************)
(*                TDetectWinVersion Version 1.0 (20.08.2007)                  *)
(*                File: Windows_Fragment.pas                                  *)
(*                Copyright  2007 by MagicAndre1981                          *)
(*                E-Mail: MagicAndre1981@hotmail.de                           *)
(*                                                                            *)
(*- - - - - - - - - - - - - - - - - - - - - - - ------------------------------*)
(*                Ich bernehme keine Haftung fr etwaige                     *)
(*                Schden, die durch diese Komponente verursacht              *)
(*                werden.                                                     *)
(*- - - - - - - - - - - - - - - - - - - - - - - ------------------------------*)
(*                Diese Komponente ist FREEWARE.                              *)
(*                Alle Rechte vorbehalten                                     *)
(*                Credits an MSimmack                                         *)
(******************************************************************************)
unit Windows_Fragment;

interface

uses
  Windows, SysUtils;

type
  POSVersionInfoA = ^TOSVersionInfoA;
  POSVersionInfoW = ^TOSVersionInfoW;
  POSVersionInfo = POSVersionInfoA;
  _OSVERSIONINFOA = record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformId: DWORD;
    szCSDVersion: array[0..127] of AnsiChar; { Maintenance string for PSS usage }
    wServicePackMajor,
    wServicePackMinor,
    wSuiteMask         : word;
    wProductType,
    wReserved          : byte;
  end;
  {$EXTERNALSYM _OSVERSIONINFOA}
  _OSVERSIONINFOW = record
    dwOSVersionInfoSize: DWORD;
    dwMajorVersion: DWORD;
    dwMinorVersion: DWORD;
    dwBuildNumber: DWORD;
    dwPlatformId: DWORD;
    szCSDVersion: array[0..127] of WideChar; { Maintenance string for PSS usage }
    wServicePackMajor,
    wServicePackMinor,
    wSuiteMask         : word;
    wProductType,
    wReserved          : byte;
  end;
  {$EXTERNALSYM _OSVERSIONINFOW}
  _OSVERSIONINFO = _OSVERSIONINFOA;
  TOSVersionInfoA = _OSVERSIONINFOA;
  TOSVersionInfoW = _OSVERSIONINFOW;
  TOSVersionInfo = TOSVersionInfoA;
  OSVERSIONINFOA = _OSVERSIONINFOA;
  {$EXTERNALSYM OSVERSIONINFOA}
  {$EXTERNALSYM OSVERSIONINFO}
  OSVERSIONINFOW = _OSVERSIONINFOW;
  {$EXTERNALSYM OSVERSIONINFOW}
  {$EXTERNALSYM OSVERSIONINFO}
  OSVERSIONINFO = OSVERSIONINFOA;

const
  {$EXTERNALSYM VERSIONINFOSIZEA}
  VERSIONINFOSIZEA  = sizeof(TOSVersionInfoA) -
    (sizeof(word) * 3) - (sizeof(byte) * 2);
  {$EXTERNALSYM VERSIONINFOSIZEW}
  VERSIONINFOSIZEW  = sizeof(TOSVersionInfoW) -
    (sizeof(word) * 3) - (sizeof(byte) * 2);
  {$EXTERNALSYM VERSIONINFOSIZE}
  VERSIONINFOSIZE   = VERSIONINFOSIZEA;

  //
  // RtlVerifyVersionInfo() os product type values
  //
  VER_NT_WORKSTATION                    = $0000001;
  VER_NT_DOMAIN_CONTROLLER              = $0000002;
  VER_NT_SERVER                         = $0000003;

  VER_SERVER_NT                         = $80000000;
  VER_WORKSTATION_NT                    = $40000000;
  VER_SUITE_SMALLBUSINESS               = $00000001;
  VER_SUITE_ENTERPRISE                  = $00000002;
  VER_SUITE_BACKOFFICE                  = $00000004;
  VER_SUITE_COMMUNICATIONS              = $00000008;
  VER_SUITE_TERMINAL                    = $00000010;
  VER_SUITE_SMALLBUSINESS_RESTRICTED    = $00000020;
  VER_SUITE_EMBEDDEDNT                  = $00000040;
  VER_SUITE_DATACENTER                  = $00000080;
  VER_SUITE_SINGLEUSERTS                = $00000100;
  VER_SUITE_PERSONAL                    = $00000200;
  VER_SUITE_BLADE                       = $00000400;
  VER_SUITE_EMBEDDED_RESTRICTED         = $00000800;
  VER_SUITE_SECURITY_APPLIANCE          = $00001000;

  VER_SUITE_WH_SERVER                   = $00008000;

  SM_SERVERR2	                          = 89; // Windows Server 2003 R2
  SM_STARTER                            = 88; // Starter Edition von Windows XP
  SM_MEDIACENTER                        = 87; // Windows XP media Center Edition
  SM_TABLETPC	                          = 86; // Windows XP Tablet PC Edition

  PROCESSOR_ARCHITECTURE_INTEL          =  0;
  PROCESSOR_ARCHITECTURE_MIPS           =  1;
  PROCESSOR_ARCHITECTURE_ALPHA          =  2;
  PROCESSOR_ARCHITECTURE_PPC            =  3;
  PROCESSOR_ARCHITECTURE_SHX            =  4;
  PROCESSOR_ARCHITECTURE_ARM            =  5;
  PROCESSOR_ARCHITECTURE_IA64           =  6;
  PROCESSOR_ARCHITECTURE_ALPHA64        =  7;
  PROCESSOR_ARCHITECTURE_MSIL           =  8;
  PROCESSOR_ARCHITECTURE_AMD64          =  9;
  PROCESSOR_ARCHITECTURE_IA32_ON_WIN64  = 10;

  PRODUCT_BUSINESS                      = $00000006;
  PRODUCT_BUSINESS_N                    = $00000010;
  PRODUCT_CLUSTER_SERVER                = $00000012;
  PRODUCT_DATACENTER_SERVER             = $00000008;
  PRODUCT_DATACENTER_SERVER_CORE        = $0000000C;
  PRODUCT_ENTERPRISE                    = $00000004;
  PRODUCT_ENTERPRISE_SERVER             = $0000000A;
  PRODUCT_ENTERPRISE_SERVER_CORE        = $0000000E;
  PRODUCT_ENTERPRISE_SERVER_IA64        = $0000000F;
  PRODUCT_HOME_BASIC                    = $00000002;
  PRODUCT_HOME_BASIC_N                  = $00000005;
  PRODUCT_HOME_PREMIUM                  = $00000003;
  PRODUCT_HOME_SERVER                   = $00000013;
  PRODUCT_SERVER_FOR_SMALLBUSINESS      = $00000018;
  PRODUCT_SMALLBUSINESS_SERVER          = $00000009;
  PRODUCT_SMALLBUSINESS_SERVER_PREMIUM  = $00000019;
  PRODUCT_STANDARD_SERVER               = $00000007;
  PRODUCT_STANDARD_SERVER_CORE          = $0000000D;
  PRODUCT_STARTER                       = $0000000B;
  PRODUCT_STORAGE_ENTERPRISE_SERVER     = $00000017;
  PRODUCT_STORAGE_EXPRESS_SERVER        = $00000014;
  PRODUCT_STORAGE_STANDARD_SERVER       = $00000015;
  PRODUCT_STORAGE_WORKGROUP_SERVER      = $00000016;
  PRODUCT_UNDEFINED                     = $00000000;
  PRODUCT_ULTIMATE                      = $00000001;
  PRODUCT_WEB_SERVER                    = $00000011;

  VER_SUITE_COMPUTE_SERVER              = $00004000;
  VER_SUITE_STORAGE_SERVER              = $00002000;

  PRODUCT_UNLICENSED                    = $ABCDABCD;

function GetVersionExA(var lpVersionInformation: TOSVersionInfo): BOOL; stdcall;
{$EXTERNALSYM GetVersionExA}
function GetVersionExW(var lpVersionInformation: TOSVersionInfo): BOOL; stdcall;
{$EXTERNALSYM GetVersionExW}
function GetVersionEx(var lpVersionInformation: TOSVersionInfo): BOOL; stdcall;
{$EXTERNALSYM GetVersionEx}

function GetNativeSystemInfoEx : SYSTEM_INFO;
function GetProductInfo(dwOSMajorVersion, dwOSMinorVersion,dwSpMajorVersion,
                        dwSpMinorVersion: DWord;
                        var pdwReturnedProductType: Dword): BOOL;

implementation

function GetVersionExA; external kernel32 name 'GetVersionExA';
function GetVersionExW; external kernel32 name 'GetVersionExW';
function GetVersionEx;  external kernel32 name 'GetVersionExA';

function GetProductInfo(dwOSMajorVersion,
dwOSMinorVersion,dwSpMajorVersion, dwSpMinorVersion: DWord; var
pdwReturnedProductType: Dword): BOOL;
var po :TFarProc;
    DLLWnd :THandle;
    GetProductInfo : function(  dwOSMajorVersion, dwOSMinorVersion,
                                dwSpMajorVersion, dwSpMinorVersion: DWord; var
                                pdwReturnedProductType: Dword)
                                :boolean; stdcall;
begin
  Result := FALSE;
  DLLWnd := LoadLibrary('kernel32');
  if DLLWnd > 0 then
  begin
    try
      po := GetProcAddress(DLLWnd, 'GetProductInfo');
      if po <> nil then
      begin
        @GetProductInfo := po;
        if GetProductInfo(  dwOSMajorVersion, dwOSMinorVersion, dwSpMajorVersion,
                            dwSpMinorVersion, pdwReturnedProductType) then
        Begin
          Result := TRUE;
        End
        else
          Result := FALSE;
      end
      else
        Result := FALSE;
    finally
      FreeLibrary(DLLWnd);
    end;
  end;
end;

// Use this method to avoid load issues on Windows 2000
function GetNativeSystemInfoEx : SYSTEM_INFO;
var
  temp : SYSTEM_INFO;
  po :TFarProc;
  DLLWnd :THandle;
  SI  :SYSTEM_INFO;
  GetNativeSystemInfo:procedure(var LPSYSTEM_INFO:SYSTEM_INFO);stdcall;
begin
  ZeroMemory(@temp,sizeof(temp));
  DLLWnd := LoadLibrary('kernel32');
  if DLLWnd > 0 then
    begin
      try
        po := GetProcAddress(DLLWnd, 'GetNativeSystemInfo');
        if po <> nil then
          begin
            @GetNativeSystemInfo := po;
            GetNativeSystemInfo(SI);
            result := SI;
          end
          else
          begin
            GetSystemInfo(temp);
            Result := temp;
          end;
      finally
        FreeLibrary(DLLWnd);
      end;
    end;
end;

end.