program xDTInfo;

{$DEFINE HTTP}

{$IFNDEF BCB}
{$DEFINE DEL1UP}
{$IFNDEF VER80}
{$DEFINE DEL2UP}
{$IFNDEF VER90}
{$DEFINE DEL3UP}
{$IFNDEF VER100}
{$DEFINE DEL4UP}
{$IFNDEF VER120}
{$DEFINE DEL5UP}
{$IFNDEF VER130}
{$DEFINE DEL6UP}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}

{$IFDEF DEL6UP}
{$WARN UNIT_PLATFORM OFF}
{$ENDIF}

uses
  Windows, VMDetection, SysUtils, WindowsVersionInfo
  {$IFDEF HTTP}, Classes, IdHTTP, Base64{$ENDIF};

{$IFDEF HTTP}
var
  Log: TStringList;
  Client: TIdHTTP;
{$ENDIF}

function Win9xMe: Boolean;
var
  OSVinfo: TOsVersionInfo;
begin
  ZeroMemory(@OSVinfo,sizeOf(OsVinfo));
  OSVinfo.dwOSVersionInfoSize := sizeof(TOSVERSIONINFO);
  GetVersionEx(OSVinfo);
  Result := OSVInfo.dwPlatformId <> 2;
end;

procedure AddLn(Text: String);
var
  Buf: PChar;
begin
  GetMem(Buf, Length(Text) +1);
  AnsiToOEM(PChar(Text), Buf);
  WriteLn(Buf);
  {$IFDEF HTTP}
  Log.Add(Text);
  {$ENDIF}
end;

{$IFDEF HTTP}
function MyBASE64(inp: string): string;
begin
  result := inp;
  result := Base64Encode(result);
  result := StringReplace(result, '+', '*', [rfReplaceAll]);
end;
{$ENDIF}

var
  I: Integer;
  WinType: String;
  {$IFDEF HTTP}
  EMail: String;
  SOK: boolean;
  Bestaetigung: String;
  {$ENDIF}
  xDTArray: TxDTArray;
  CPUCount: Cardinal;
  Ver: TWindowsVersionInfo;

begin
  {$IFDEF HTTP}
  Log := TStringList.Create;
  try
  {$ENDIF}
  Ver := TWindowsVersionInfo.Create;
  try

  AllocConsole;
  CPUCount := GetxDTArray(xDTArray);

  AddLn('VMM-DIAGNOSTIC TOOL, VERSION 01.10.2007');
  AddLn('BY ZACHERL AND DANIEL MARSCHALL');
  AddLn('');

  /// SYSTEM INFO //////////////////////////////////////////////////////////////
  AddLn('System Info');
  AddLn('-----------');
  AddLn(Char(VK_TAB) + 'Version  : ' + Ver.WindowsVersionsString);
  if Win9xMe then
  begin
    AddLn(Char(VK_TAB) + 'Win9x    : Yes');
    WinType := 'Win9x';
  end
    else
  begin
    AddLn(Char(VK_TAB) + 'Win9x    : No');
    WinType := 'WinNT';
  end;
  AddLn(Format(Char(VK_TAB) + 'CPU count: %d', [CPUCount]));
  AddLn('');
  //////////////////////////////////////////////////////////////////////////////

  /// CPU INFOS ////////////////////////////////////////////////////////////////
  for I := 1 to CPUCount do
  begin
    AddLn(Format('Processor #%2d', [I]));
    AddLn('-------------');
    AddLn(Format(Char(VK_TAB) + 'GDT : 0x' + IntToHex(xDTArray[I -1].GDTBase,
      8) + ' <%5d>', [xDTArray[I -1].GDTLimit]));
    AddLn(Format(Char(VK_TAB) + 'IDT : 0x' + IntToHex(xDTArray[I -1].IDTBase,
      8) + ' <%5d>', [xDTArray[I -1].IDTLimit]));
    AddLn(Char(VK_TAB) + 'LDTR: 0x' + IntToHex(xDTArray[I -1].LDTRBase, 8)
      + ' <' + WinType + '>');
    AddLn(Char(VK_TAB) + 'Type: ' + VMFingerprintToStr(GetVMFingerprint(
      xDTArray[I -1])));
    AddLn('');
  end;
  AddLn('');
  //////////////////////////////////////////////////////////////////////////////

  /// RESULT ///////////////////////////////////////////////////////////////////
  if IsVirtualMachine then
  begin
    AddLn('This application is [probably] running IN a virtual machine!');
  end
    else
  begin
    AddLn('This application is [probably] NOT running in a virtual machine!');
  end;
  //////////////////////////////////////////////////////////////////////////////

  /// SEND /////////////////////////////////////////////////////////////////////
  {$IFDEF HTTP}
  WriteLn('');
  WriteLn('Please press ENTER to send the output to our http server ...');
  WriteLn('Type EXIT if you do not want to send the output.');
  WriteLn('');
  ReadLn(Bestaetigung);

  if UpperCase(Bestaetigung) <> 'EXIT' then
  begin
    WriteLn('Please enter the name of your virtualization-software or NATIVE if you');
    WriteLn('do not use a virtualization-software: ');
    WriteLn('');
    ReadLn(WinType);
    Log.Add('User-Input "Virtual": ' + WinType);
    WriteLn('');
    WriteLn('If you want, you can enter your email-address, your name or');
    WriteLn('some comments here. You do not have to.');
    WriteLn('');
    ReadLn(EMail);
    Log.Add('User-Input "E-Mail": ' + EMail);
    WriteLn('');
    WriteLn('Plase wait...');
    WriteLn('');

    SOK := false;
    Client := TIdHTTP.Create(nil);
    try
      try
        SOK := (Client.Get('http://www.daniel-marschall.de/vm/send.php?bas='
                + MyBASE64(Log.Text))) = 'OK';
      except
      end;
    finally
      Client.Free;
    end;

    if SOK then
    begin
      WriteLn('The output was successfully sent to our server.');
    end
    else
    begin
      Log.SaveToFile(ExtractFilePath(ParamStr(0)) + 'xLog.txt');

      WriteLn('WARNING! The program could NOT send the file to our server!');
      WriteLn('We would be glad if you could send us the result via e-mail!');
      WriteLn('');
      WriteLn('PLEASE send the file "xLog.txt" to info@daniel-marschall.de');
    end;

    WriteLn('');
    WriteLn('Thank you very much! :)');
  end;
  {$ENDIF}
  //////////////////////////////////////////////////////////////////////////////

  finally
  Ver.Free;
  end;
  {$IFDEF HTTP}
  finally
  Log.Free;
  end;
  {$ENDIF}

  WriteLn('');
  WriteLn('Press ENTER to close this window.');
  WriteLn('');

  ReadLn;
  FreeConsole;
end.
